LeetCode860. Lemonade Change

文章目录

一、题目

At a lemonade stand, each lemonade costs 5. Customers are standing in a queue to buy from you and order one at a time (in the order specified by bills). Each customer will only buy one lemonade and pay with either a 5, 10, or 20 bill. You must provide the correct change to each customer so that the net transaction is that the customer pays $5.

Note that you do not have any change in hand at first.

Given an integer array bills where billsi is the bill the ith customer pays, return true if you can provide every customer with the correct change, or false otherwise.

Example 1:

Input: bills = 5,5,5,10,20

Output: true

Explanation:

From the first 3 customers, we collect three $5 bills in order.

From the fourth customer, we collect a 10 bill and give back a 5.

From the fifth customer, we give a 10 bill and a 5 bill.

Since all customers got correct change, we output true.

Example 2:

Input: bills = 5,5,10,10,20

Output: false

Explanation:

From the first two customers in order, we collect two $5 bills.

For the next two customers in order, we collect a 10 bill and give back a 5 bill.

For the last customer, we can not give the change of 15 back because we only have two 10 bills.

Since not every customer received the correct change, the answer is false.

Constraints:

1 <= bills.length <= 105

billsi is either 5, 10, or 20.

二、题解

cpp 复制代码
class Solution {
public:
    bool lemonadeChange(vector<int>& bills) {
        int n = bills.size();
        vector<int> balance(3,0);
        for(int i = 0;i < n;i++){
            int sub = bills[i] - 5;
            if(sub == 5 && balance[0] == 0) return false;
            else if(sub == 15 && (balance[0] == 0 || (balance[1] == 0 && balance[0] < 3))) return false;
            if(sub == 5) balance[0]--;
            else if(sub == 15){
                if(balance[1] > 0) balance[0]--,balance[1]--;
                else balance[0] -= 3;
            }
            if(bills[i] == 5) balance[0]++;
            else if(bills[i] == 10) balance[1]++;
            else balance[2]++;
        }
        return true;
    }
};

更好的解法

cpp 复制代码
class Solution {
public:
    bool lemonadeChange(vector<int>& bills) {
        int n = bills.size();
        int five = 0,ten = 0,twenty = 0;
        for(int i = 0;i < n;i++){
            if(bills[i] == 5) five++;
            else if(bills[i] == 10){
                if(five == 0) return false;
                ten++;
                five--;
            }
            else if(bills[i] == 20){
                if(five > 0 && ten > 0) five--,ten--;
                else if(five >= 3 && ten == 0) five -= 3;
                else return false;
            }
        }
        return true;
    }
};
相关推荐
蜗牛一步步往上爬2 小时前
第十六章 C++语言在深度学习中的应用
开发语言·c++·深度学习
likexuec4 小时前
数据结构(2)
数据结构
文丑颜不良啊5 小时前
LeetCode2221~2240题目解析
java·leetcode
Navigator_Z5 小时前
LeetCode //C - 1317. Convert Integer to the Sum of Two No-Zero Integers
c语言·算法·leetcode
wo_jack5 小时前
C++ 入门笔记(十六):第16课 vector 模拟实现十问十答 —— 从三指针到迭代器失效
c++·后端·面试·stl·vector
D e re k ZH6 小时前
C++ 标准库算法全景指南
数据结构·c++·算法
冻柠檬飞冰走茶7 小时前
字母移动游戏题解:贪心求最长可保留连续子串(附 C 实现)
c语言·开发语言·数据结构·算法·动态规划
文丑颜不良啊7 小时前
LeetCode2161~2180题目解析
java·leetcode
雪落漂泊7 小时前
C++算法 二分查找篇(上)
开发语言·c++·算法